function makeSVG(tag, attrs) {
    var el= document.createElementNS('http://www.w3.org/2000/svg', tag);
    for (var k in attrs)
        el.setAttribute(k, attrs[k]);
    return el;
}

function transform(el, x, y) {
    el.setAttribute('transform', 'matrix(1 0 0 1 ' + x.toString() + ' ' + y.toString() + ')');
}

function transform2(svg, el, x, y) {
    var xforms = el.transform.baseVal;
    xforms.clear();
    var matrix = svg.createSVGMatrix();
    var transform = svg.createSVGTransformFromMatrix(matrix.translate(x,y));
    xforms.appendItem(transform);
}

$(window).ready(function() {
    var canvas = document.getElementById("canvas");
    var canvas2 = document.getElementById("canvas2");

    var g = makeSVG('g', {});
    var rect = makeSVG('rect', {x: 100, y:100, width: 100, height: 100, fill: 'red'});

    // transform(g, 300, 300);
    transform2(canvas, g, 300, 300);

    g.appendChild(rect);

    // transform(g, 300, 300);
    // transform2(canvas, g, 300, 300);

    canvas.appendChild(g);

    // transform(g, 300, 300);
    // transform2(canvas, g, 300, 300);

    var i = 0;
    var btn = document.getElementById("btn");
    btn.addEventListener('click', (function() {
        if (i%2 === 0) {
            // transform2(canvas, g, 100, 100);
            canvas.removeChild(g);
            transform2(canvas, g, 100, 100);
            canvas2.appendChild(g);
            // transform2(canvas, g, 100, 100);
        } else {
            // transform2(canvas, g, 50, 50);
            canvas2.removeChild(g);
            transform2(canvas, g, 50, 50);
            canvas.appendChild(g);
            // transform2(canvas, g, 50, 50);
        }
        ++i;
    }));
});
